#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Enter the description of your new custom indicator here
    /// </summary>
    [Description("Enter the description of your new custom indicator here")]
    public class PlotADD : Indicator
    {
        #region Variables
        // Wizard generated variables
        // User defined variables (add any user defined variables below)
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            Add(new Plot(Color.FromKnownColor(KnownColor.RoyalBlue), PlotStyle.Line, "AddLine"));
            Add(new Line(Color.FromKnownColor(KnownColor.DarkOliveGreen), 0, "Zero"));
			
			Add ("^ADV", PeriodType.Minute, 1);
			Add ("^DECL", PeriodType.Minute, 1);
			
            Overlay				= false;
			CalculateOnBarClose = false;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
			if (CurrentBars[0] < 1 || CurrentBars[1] < 1 || CurrentBars[2] < 1)
				return;
			
			if (BarsInProgress == 0)
			{
            	AddLine.Set(Closes[1][0] - Closes[2][0]);
			}
        }

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries AddLine
        {
            get { return Values[0]; }
        }

        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private PlotADD[] cachePlotADD = null;

        private static PlotADD checkPlotADD = new PlotADD();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public PlotADD PlotADD()
        {
            return PlotADD(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public PlotADD PlotADD(Data.IDataSeries input)
        {
            if (cachePlotADD != null)
                for (int idx = 0; idx < cachePlotADD.Length; idx++)
                    if (cachePlotADD[idx].EqualsInput(input))
                        return cachePlotADD[idx];

            lock (checkPlotADD)
            {
                if (cachePlotADD != null)
                    for (int idx = 0; idx < cachePlotADD.Length; idx++)
                        if (cachePlotADD[idx].EqualsInput(input))
                            return cachePlotADD[idx];

                PlotADD indicator = new PlotADD();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                PlotADD[] tmp = new PlotADD[cachePlotADD == null ? 1 : cachePlotADD.Length + 1];
                if (cachePlotADD != null)
                    cachePlotADD.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachePlotADD = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PlotADD PlotADD()
        {
            return _indicator.PlotADD(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.PlotADD PlotADD(Data.IDataSeries input)
        {
            return _indicator.PlotADD(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PlotADD PlotADD()
        {
            return _indicator.PlotADD(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.PlotADD PlotADD(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.PlotADD(input);
        }
    }
}
#endregion
